/*
 * CommunitiesView.java
 *
 * Created on 25 de agosto de 2004, 03:52 PM
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.CommunityList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.CommunityListView;

/**
 * Este servlet permite crear los objetos que recibirá el listado comunidades
 * que pertenecen a un proveedor.
 * 
 * @author Juan Ernesto Peña K.
 * @version
 */

public class CommunitiesView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa la peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método recibe el id de un proveedor en el request. -Crea un objeto
	 * de tipo CommunityList con el id de un proveedor -Crea un objeto de tipo
	 * CommunityListView con el objeto anterior -Manda el objeto
	 * communityListView en el response -Redirecciona a comunidades.jsp
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Repuesta del servlet
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;

		String url;
		String message;
		boolean flag = true;

		//Validación de sesión
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
	
			}
			else
			{
				User supplier = (User) session.getAttribute("user");
				CommunityList communityList = new CommunityList(supplier
						.getCompanyId());
				CommunityListView communityListView = new CommunityListView(
						communityList);
				url = "/proveedor/comunidades.jsp";
	
				if( communityListView == null )
				{
					//Fallo en la creación del listado de comunidades
					//message = "Fallo en la creación del listado de comunidades";
					message = MessageBuilder.buildMessage(9);
	
				}
				else
				{
					//Todo OK
					//message = "La carga del listado finalizó correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					request.setAttribute("view", communityListView);
	
				}
			}
	
			if( request.getAttribute("message") != null )
			{
				message = (String) request.getAttribute("message");
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Repuesta del servlet
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Repuesta del servlet
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}